//+------------------------------------------------------------------+
//|                                                   GenerateRB.mq4 |
//|                                   Copyright 2016, Harrison Forex |
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright "Copyright 2016, Harrison Forex"
#property link      ""
#property version   "1.00"
#property strict
//--- input parameters
input int      range                                           = 10;


int             unused[13], csvHndl, hstHndl;
double          last, nPoint = 1;
datetime        now;

/*
extern string   file                                            = "";
extern bool     printRecords                                 = false;
*/
MqlRates        rate;
//+------------------------------------------------------------------+
//| Script program start function                                    |
//+------------------------------------------------------------------+
void init ()
{
    int x;
    if (Digits % 2 == 0) x = Digits; else { x = Digits-1; }
    while (x > 0) { nPoint /= 10; x--; }

    string file = Symbol()+(string)range+"r";
    hstHndl = FileOpenHistory(file + ".hst", FILE_BIN|FILE_WRITE|FILE_SHARE_WRITE|FILE_SHARE_READ);
    csvHndl = FileOpenHistory(file + ".csv", FILE_CSV|FILE_WRITE|FILE_SHARE_WRITE|FILE_SHARE_READ);
    
    PrintFormat("File path: %s\\Files\\",TerminalInfoString(TERMINAL_DATA_PATH));
    
    FileWriteLong(hstHndl, 401);                                    // version
    FileWriteString(hstHndl, "Copyright  2016 Harrison Forex", 64);//c_copyright
    string sym = Symbol();
    FileWriteString(hstHndl, sym, 12);                              // c_symbol
    FileWriteInteger(hstHndl, 5, LONG_VALUE);                       //i_period
    FileWriteInteger(hstHndl, 4, LONG_VALUE);                       //i_digits
    FileWriteLong(hstHndl, TimeCurrent());                          //time_sign
    FileWriteInteger(hstHndl, 0, LONG_VALUE);                       //last_sync
    FileWriteArray(hstHndl, unused, 0);
    
    rate.high = Close[0]; 
    rate.low = Close[0]; 
    rate.open = Close[0];
    rate.time = TimeCurrent(); 
    rate.real_volume = 0; 
    rate.tick_volume = 0;
    rate.spread = 2;
}
//+------------------------------------------------------------------+
//+------------------------------------------------------------------+
//| script program start function                                    |
//+------------------------------------------------------------------+
void OnTick()
{
    now = TimeCurrent();
    //if (last == Close[0]) return;
    last = Close[0];

    rate.high = MathMax(rate.high, Close[0]);
    rate.low = MathMin(rate.low, Close[0]);
    
    if (rate.high-rate.low > range * nPoint) {
        Print(rate.high," ",rate.low," ",rate.high-rate.low);
        while (rate.high-rate.low > range * nPoint) {
            int idx, idx2, dirn;
            dirn = (sign(last-rate.high) + sign(last-rate.low));
            idx = (1-dirn)/2; 
            idx2 = (1+dirn)/2;
            //dirn      idx idx2
            // +1        0   1
            // -1        1   0
            rate.low = iif(idx == 0, rate.low, rate.high - range * nPoint);
            rate.high = iif(idx == 0, rate.low + range * nPoint, rate.high);
            rate.close = iif(idx == 0, rate.high, rate.low);
            
            FileWriteStruct(hstHndl, rate);
            FileFlush(hstHndl);
            FileWrite(csvHndl,rate.time, rate.open, rate.low, rate.high, rate.close,rate.real_volume,rate.spread,rate.tick_volume);
            FileFlush(csvHndl);

            rate.low = rate.close; rate.high = rate.close; rate.open = rate.close; rate.time = TimeCurrent();
            rate.high = MathMax(rate.high, Close[0]);
            rate.low = MathMin(rate.low, Close[0]);
            rate.real_volume = 0; rate.tick_volume = 0;
        }
    } else {
        rate.tick_volume++; rate.real_volume++; rate.close = last;
    }    
    /*
    Comment("\n"+dateTime(now)+"\n"+DoubleToStr(rate.open,Digits)+" "+
    DoubleToStr(rate.high,Digits)+" "+DoubleToStr(rate.low,Digits)+" "+
    (string)rate.real_volume," ",rate.tick_volume);
    */
    return;
}
//+------------------------------------------------------------------+
string dateTime(datetime pNow)
{
    string dDateTime;
    
    switch(TimeDayOfWeek(pNow))
    {
        case 0: { dDateTime = "Sunday "; break; }
        case 1: { dDateTime = "Monday "; break; }
        case 2: { dDateTime = "Tuesday "; break; }
        case 3: { dDateTime = "Wednesday "; break; }
        case 4: { dDateTime = "Thursday "; break; }
        case 5: { dDateTime = "Friday "; break; }
        case 6: { dDateTime = "Saturday "; break; }
    }
    dDateTime = dDateTime+" "+TimeToStr(pNow,TIME_DATE)+" "+TimeToStr(pNow,TIME_SECONDS);
    
    return(dDateTime);
}
//+------------------------------------------------------------------+
void deinit()
{
    FileFlush(hstHndl);
    FileClose(hstHndl);
	FileFlush(csvHndl);
	FileClose(csvHndl);
    if (hstHndl > 0) {
    /*
        FileSeek(hstHndl, 0x58, SEEK_SET);
        FileWriteInteger(hstHndl, (int)TimeCurrent());
        FileFlush(csvHndl);
    */
        FileClose(hstHndl);
    }    
 	if (csvHndl > 0) {
 		FileClose(csvHndl);
 	}       
}
//---------------------------------------------------
double iif( bool condition, double ifTrue, double ifFalse )
{
    if( condition ) return( ifTrue );
    
    return( ifFalse );
}
//----------------------------------------
int sign( double val)
{
    if (val < 0) return(-1);
    if (val > 0) return(1);
    return(0);
}
